"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WidgetDCFCellExample = exports.WidgetDCFCell = void 0;
const react_1 = __importStar(require("react"));
const DependentTabs_1 = require("./DependentTabs");
const ColumnsEditor_1 = require("./ColumnsEditor");
const staticData_1 = require("./staticData");
const DFViewer_1 = require("./DFViewer");
const StatusBar_1 = require("./StatusBar");
const bakedOperationDefaults_1 = require("./bakedOperationDefaults");
const OperationUtils_1 = require("./OperationUtils");
/*
  Widget DCFCell is meant to be used with callback functions and passed values, not explicit http calls

  TODO:add height settings to dfConfig rather than hardcoded.
 */
function WidgetDCFCell({ df_json: json_serialized_df, operations, on_operations, operation_results, commandConfig, dfConfig, on_dfConfig, summary_df_json: summaryDf, }) {
    const [activeCol, setActiveCol] = (0, react_1.useState)('stoptime');
    const widgetConfig = { showCommands: dfConfig.showCommands };
    const localDfConfig = Object.assign(Object.assign({}, dfConfig), { rowsShown: json_serialized_df.data.length || 0 });
    return (react_1.default.createElement("div", { className: "dcf-root flex flex-col", style: { width: '100%', height: '100%' } },
        react_1.default.createElement("div", { className: "orig-df flex flex-row", style: { height: '450px', overflow: 'hidden' } },
            react_1.default.createElement(StatusBar_1.StatusBar, { config: localDfConfig, setConfig: on_dfConfig }),
            react_1.default.createElement(DFViewer_1.DFViewer, { df: dfConfig.summaryStats ? summaryDf : json_serialized_df, activeCol: activeCol, setActiveCol: setActiveCol })),
        widgetConfig.showCommands ? (react_1.default.createElement(ColumnsEditor_1.ColumnsEditor, { df: json_serialized_df, activeColumn: activeCol, operations: operations, setOperations: on_operations, operationResult: operation_results, commandConfig: commandConfig, widgetConfig: widgetConfig })) : (react_1.default.createElement("span", null))));
}
exports.WidgetDCFCell = WidgetDCFCell;
function WidgetDCFCellExample() {
    const [sampleConfig, setConfig] = (0, react_1.useState)({
        totalRows: 1309,
        columns: 30,
        rowsShown: 500,
        sampleSize: 10000,
        sampled: true,
        summaryStats: false,
        showCommands: true,
        //reorderdColumns: false,
    });
    const [operations, setOperations] = (0, react_1.useState)(OperationUtils_1.bakedOperations);
    return (react_1.default.createElement(WidgetDCFCell, { df_json: staticData_1.tableDf, operations: operations, on_operations: setOperations, operation_results: DependentTabs_1.baseOperationResults, commandConfig: bakedOperationDefaults_1.bakedCommandConfig, dfConfig: sampleConfig, on_dfConfig: setConfig, summary_df_json: staticData_1.tableDf }));
}
exports.WidgetDCFCellExample = WidgetDCFCellExample;
//# sourceMappingURL=DCFCell.js.map