"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DFViewer = void 0;
const react_1 = __importStar(require("react"));
const lodash_1 = __importDefault(require("lodash"));
const staticData_1 = require("./staticData");
const gridUtils_1 = require("./gridUtils");
const ag_grid_react_1 = require("ag-grid-react"); // the AG Grid React Component
const CustomHeader_1 = require("./CustomHeader");
function DFViewer({ df, style, activeCol, setActiveCol, } = {
    df: staticData_1.EmptyDf,
    style: { height: '300px' },
    setActiveCol: () => null,
}) {
    const [agColsPure, agData] = (0, gridUtils_1.dfToAgrid)(df);
    // console.log('dfviewer agData', agData);
    const styledColumns = (0, gridUtils_1.updateAtMatch)(lodash_1.default.clone(agColsPure), activeCol || '___never', {
        cellStyle: { background: 'var(--ag-range-selection-background-color-3)' },
    }, { cellStyle: {} });
    const gridOptions = {
        rowSelection: 'single',
        onRowClicked: (event) => console.log('A row was clicked'),
        defaultColDef: {
            sortable: true,
            type: 'rightAligned',
            cellRendererSelector: (params) => {
                if (params.node.rowPinned) {
                    return {
                        component: CustomHeader_1.HistogramCell,
                        params: {
                            style: { fontStyle: 'italic' },
                        },
                    };
                }
                else {
                    // rows that are not pinned don't use any cell renderer
                    return undefined;
                }
            },
        },
        onCellClicked: (event) => {
            const colName = event.column.getColId();
            if (setActiveCol === undefined || colName === undefined) {
                return;
            }
            else {
                setActiveCol(colName);
            }
        },
    };
    const gridRef = (0, react_1.useRef)(null);
    const makeCondtionalAutosize = (count, delay) => {
        /*
          this code is buggy and I'm not confident in it. I'm very
          surprised that automatically autosizing AG-grid requires custom
          functions to be written vs just a flag.
          */
        var _a;
        let counter = count;
        //let timer: NodeJS.Timeout;
        let timer;
        let colWidthHasBeenSet = false;
        let currentColWidth = -10;
        if (gridRef === undefined || gridRef.current === null) {
            currentColWidth = 200;
        }
        else {
            try {
                const dc = (_a = gridRef === null || gridRef === void 0 ? void 0 : gridRef.current) === null || _a === void 0 ? void 0 : _a.columnApi.getAllDisplayedColumns();
                if (dc.length !== 0) {
                    currentColWidth = dc[0].getActualWidth();
                }
                else {
                    currentColWidth = 200;
                }
            }
            catch (e) {
                console.log('88, gridref not defined yet', e);
            }
        }
        const conditionallyAutosize = () => {
            if (gridRef !== undefined) {
                if (gridRef.current !== undefined && gridRef.current !== null) {
                    if (gridRef.current.columnApi !== undefined) {
                        gridRef.current.columnApi.autoSizeAllColumns();
                        const dc = gridRef.current.columnApi.getAllDisplayedColumns();
                        // console.log("bodyWidth", cm.bodyWidth)
                        // console.log("cm", cm)
                        if (dc.length !== 0) {
                            const aw = dc[0].getActualWidth(); // this eventually changes after the resize
                            //console.log("dc", aw);
                            if (colWidthHasBeenSet === false) {
                                currentColWidth = aw;
                                colWidthHasBeenSet = true;
                            }
                            else {
                                currentColWidth = aw;
                            }
                        }
                        gridRef.current.forceUpdate();
                    }
                }
            }
            //	    console.log("counter", counter, "colWidthHasBeenSet", colWidthHasBeenSet, originalColWidth, currentColWidth);
            if (counter > 0 && colWidthHasBeenSet === false) {
                counter -= 1;
                // console.log("no gridRef or gridRef.current, setting delay", counter)
                timer = window.setTimeout(conditionallyAutosize, delay);
                return;
            }
            else if (counter > 0 && currentColWidth === 200) {
                counter -= 1;
                // console.log(
                //     "new colwidth not recognized yet",
                //     counter, originalColWidth, gridRef.current!.columnApi!.columnModel!.displayedColumns[0].actualWidth)
                timer = window.setTimeout(conditionallyAutosize, delay);
                return;
            }
        };
        timer = window.setTimeout(conditionallyAutosize, delay);
        return () => window.clearTimeout(timer);
    };
    makeCondtionalAutosize(50, 350);
    const pinnedTopRowData = [df.table_hints];
    return (react_1.default.createElement("div", { className: "df-viewer" },
        react_1.default.createElement("div", { style: { height: 400 }, className: "theme-hanger ag-theme-alpine-dark" },
            react_1.default.createElement(ag_grid_react_1.AgGridReact, { ref: gridRef, gridOptions: gridOptions, rowData: agData, pinnedTopRowData: pinnedTopRowData, columnDefs: styledColumns }))));
}
exports.DFViewer = DFViewer;
//# sourceMappingURL=DFViewer.js.map