export interface ObjDisplayerA {
    displayer: 'obj';
}
export interface BooleanDisplayerA {
    displayer: 'boolean';
}
export interface StringDisplayerA {
    displayer: 'string';
}
export interface FloatDisplayerA {
    displayer: 'float';
}
export interface HistogramDisplayerA {
    displayer: 'histogram';
}
export interface DatetimeDefaultDisplayerA {
    displayer: 'datetimeDefault';
}
export interface IntegerDisplayerA {
    displayer: 'integer';
    min_digits: number;
    max_digits: number;
}
export interface ColorMapRules {
    color_rule: 'color_map';
    map_name: "BLUE_TO_YELLOW" | 'DIVERGING_RED_WHITE_BLUE';
}
export interface ErrorMapRules {
    color_rule: 'error_map';
    conditional_color: 'red';
    exist_column: string;
}
export type ColorMappingRules = ColorMapRules | ErrorMapRules;
export interface DatetimeLocaleDisplayerA {
    displayer: 'datetimeLocaleString';
    locale: 'en-US' | 'en-GB' | 'en-CA' | 'fr-FR' | 'es-ES' | 'de-DE' | 'ja-JP';
    args: Intl.DateTimeFormatOptions;
}
export type FormatterArgs = ObjDisplayerA | BooleanDisplayerA | StringDisplayerA | FloatDisplayerA | DatetimeDefaultDisplayerA | DatetimeLocaleDisplayerA | IntegerDisplayerA;
export type CellRendererArgs = HistogramDisplayerA;
export type DisplayerArgs = FormatterArgs | CellRendererArgs;
export declare const cellRendererDisplayers: string[];
export interface DFColumn {
    name: string;
    type: string;
}
export type DFDataRow = Record<string, string | number | boolean | any[] | Record<string, any> | null>;
export type DFData = DFDataRow[];
export interface SDFMeasure {
    histogram_bins: number[];
    histogram_log_bins: number[];
}
export type SDFT = Record<string, SDFMeasure>;
export type ColumnConfig = {
    col_name: string;
    displayer_args: DisplayerArgs;
    highlight_rules?: ColorMapRules;
};
export type PinnedRowConfig = {
    primary_key_val: string;
    displayer_args: DisplayerArgs;
    highlight_rules?: any;
    tooltip_rules?: any;
};
export interface DFViewerConfig {
    pinned_rows: PinnedRowConfig[];
    column_config: ColumnConfig[];
}
export interface DFWhole {
    dfviewer_config: DFViewerConfig;
    data: DFData;
}
export declare const EmptyDf: DFWhole;
