"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatusBarEx = exports.StatusBar = void 0;
// https://plnkr.co/edit/QTNwBb2VEn81lf4t?open=index.tsx
const react_1 = __importStar(require("react"));
const ag_grid_react_1 = require("ag-grid-react"); // the AG Grid React Component
const gridUtils_1 = require("./gridUtils");
const columnDefs = [
    {
        field: 'summaryStats',
        headerName: 'Σ',
        headerTooltip: 'Summary Stats',
        width: 30,
    },
    //   { field: 'reorderdColumns',
    //   headerName: "Θ",
    //   headerTooltip:"Reorder Columns",
    //   width:30
    // },
    {
        field: 'showCommands',
        headerName: 'λ',
        headerTooltip: 'Show Commands',
        width: 30,
    },
    { field: 'sampled', headerName: 'Ξ', headerTooltip: 'Sampled', width: 30 },
    {
        field: 'help',
        headerName: '?',
        headerTooltip: 'Help',
        width: 30,
        cellRenderer: function (params) {
            return (react_1.default.createElement("a", { href: "https://buckaroo-data.readthedocs.io/en/latest/feature_reference.html", target: "_blank", rel: "noopener" }, "?"));
        },
    },
    { field: 'totalRows', width: 100 },
    { field: 'columns', width: 100 },
    { field: 'rowsShown', width: 120 },
    { field: 'sampleSize', width: 120 },
];
function StatusBar({ config, setConfig, }) {
    const { totalRows, columns, rowsShown, sampleSize, sampled, summaryStats, showCommands,
    //reorderdColumns
     } = config;
    const rowData = [
        {
            totalRows: gridUtils_1.basicIntFormatter.format(totalRows),
            columns,
            rowsShown: gridUtils_1.basicIntFormatter.format(rowsShown),
            sampleSize: gridUtils_1.basicIntFormatter.format(sampleSize),
            sampled: sampled ? '1' : '0',
            summaryStats: summaryStats ? '1' : '0',
            // reorderdColumns: reorderdColumns ? "1" : "ό",
            showCommands: showCommands ? '1' : '0',
        },
    ];
    const updateDict = (event) => {
        const colName = event.column.getColId();
        if (colName === 'summaryStats') {
            setConfig(Object.assign(Object.assign({}, config), { summaryStats: !config.summaryStats }));
        }
        else if (colName === 'sampled') {
            setConfig(Object.assign(Object.assign({}, config), { sampled: !config.sampled }));
        }
        else if (colName === 'showCommands') {
            setConfig(Object.assign(Object.assign({}, config), { showCommands: !config.showCommands }));
        }
        // } else if (colName === 'reorderdColumns') {
        //   setConfig({ ...config, reorderdColumns: !config.reorderdColumns });
    };
    const gridOptions = {
        rowSelection: 'single',
    };
    const gridRef = (0, react_1.useRef)(null);
    const defaultColDef = {
        type: 'left-aligned',
        cellStyle: { textAlign: 'left' },
    };
    return (react_1.default.createElement("div", { className: "statusBar" },
        react_1.default.createElement("div", { style: { height: 50 }, className: "theme-hanger ag-theme-alpine-dark" },
            react_1.default.createElement(ag_grid_react_1.AgGridReact, { ref: gridRef, onCellClicked: updateDict, gridOptions: gridOptions, defaultColDef: defaultColDef, rowData: rowData, columnDefs: columnDefs }))));
}
exports.StatusBar = StatusBar;
function StatusBarEx() {
    const [sampleConfig, setConfig] = (0, react_1.useState)({
        totalRows: 1309,
        columns: 30,
        rowsShown: 500,
        sampleSize: 10000,
        sampled: true,
        summaryStats: false,
        showCommands: true,
        //reorderdColumns: true,
    });
    return react_1.default.createElement(StatusBar, { config: sampleConfig, setConfig: setConfig });
}
exports.StatusBarEx = StatusBarEx;
//# sourceMappingURL=StatusBar.js.map