import { ColDef, ValueFormatterFunc, ValueFormatterParams } from 'ag-grid-community';
import { DFWhole, ColumnDatetimeHint } from './staticData';
export declare const updateAtMatch: (cols: ColDef[], key: string, subst: Partial<ColDef>, negative: Partial<ColDef>) => {
    colId?: string | undefined;
    field?: string | undefined;
    type?: string | string[] | undefined;
    valueGetter?: string | import("ag-grid-community").ValueGetterFunc<any> | undefined;
    valueFormatter?: string | ValueFormatterFunc<any> | undefined;
    refData?: {
        [key: string]: string;
    } | undefined;
    keyCreator?: ((params: import("ag-grid-community").KeyCreatorParams<any, any>) => string) | undefined;
    equals?: ((valueA: any, valueB: any) => boolean) | undefined;
    tooltipField?: string | undefined;
    tooltipValueGetter?: ((params: import("ag-grid-community").ITooltipParams<any, any, any>) => any) | undefined;
    checkboxSelection?: boolean | import("ag-grid-community").CheckboxSelectionCallback<any> | undefined;
    showDisabledCheckboxes?: boolean | undefined;
    icons?: {
        [key: string]: string | Function;
    } | undefined;
    suppressNavigable?: boolean | import("ag-grid-community").SuppressNavigableCallback<any> | undefined;
    suppressKeyboardEvent?: ((params: import("ag-grid-community").SuppressKeyboardEventParams<any>) => boolean) | undefined;
    suppressPaste?: boolean | import("ag-grid-community").SuppressPasteCallback<any> | undefined;
    suppressFillHandle?: boolean | undefined;
    hide?: boolean | undefined;
    initialHide?: boolean | undefined;
    lockVisible?: boolean | undefined;
    lockPosition?: boolean | "left" | "right" | undefined;
    suppressMovable?: boolean | undefined;
    editable?: boolean | import("ag-grid-community").EditableCallback<any> | undefined;
    valueSetter?: string | import("ag-grid-community").ValueSetterFunc<any> | undefined;
    valueParser?: string | import("ag-grid-community").ValueParserFunc<any, any> | undefined;
    cellEditor?: any;
    cellEditorFramework?: any;
    cellEditorParams?: any;
    cellEditorSelector?: import("ag-grid-community").CellEditorSelectorFunc<any> | undefined;
    singleClickEdit?: boolean | undefined;
    cellEditorPopup?: boolean | undefined;
    cellEditorPopupPosition?: "over" | "under" | undefined;
    onCellValueChanged?: ((event: import("ag-grid-community").NewValueParams<any>) => void) | undefined;
    onCellClicked?: ((event: import("ag-grid-community").CellClickedEvent<any, any>) => void) | undefined;
    onCellDoubleClicked?: ((event: import("ag-grid-community").CellDoubleClickedEvent<any, any>) => void) | undefined;
    onCellContextMenu?: ((event: import("ag-grid-community").CellContextMenuEvent<any, any>) => void) | undefined;
    getQuickFilterText?: ((params: import("ag-grid-community").GetQuickFilterTextParams<any, any>) => string) | undefined;
    filterValueGetter?: string | import("ag-grid-community").ValueGetterFunc<any> | undefined;
    floatingFilter?: boolean | undefined;
    wrapHeaderText?: boolean | undefined;
    autoHeaderHeight?: boolean | undefined;
    headerComponent?: any;
    headerComponentFramework?: any;
    headerComponentParams?: any;
    menuTabs?: import("ag-grid-community").ColumnMenuTab[] | undefined;
    columnsMenuParams?: import("ag-grid-community").ColumnsMenuParams | undefined;
    suppressMenu?: boolean | undefined;
    headerCheckboxSelection?: boolean | import("ag-grid-community").HeaderCheckboxSelectionCallback<any> | undefined;
    headerCheckboxSelectionFilteredOnly?: boolean | undefined;
    headerCheckboxSelectionCurrentPageOnly?: boolean | undefined;
    chartDataType?: "time" | "category" | "series" | "excluded" | undefined;
    pinned?: boolean | "left" | "right" | null | undefined;
    initialPinned?: boolean | "left" | "right" | undefined;
    lockPinned?: boolean | undefined;
    pivot?: boolean | undefined;
    initialPivot?: boolean | undefined;
    pivotIndex?: number | null | undefined;
    initialPivotIndex?: number | undefined;
    pivotComparator?: ((valueA: string, valueB: string) => number) | undefined;
    enablePivot?: boolean | undefined;
    cellStyle?: import("ag-grid-community").CellStyle | import("ag-grid-community").CellStyleFunc<any> | undefined;
    cellClass?: string | string[] | import("ag-grid-community").CellClassFunc<any> | undefined;
    cellClassRules?: import("ag-grid-community").CellClassRules<any> | undefined;
    cellRenderer?: any;
    cellRendererFramework?: any;
    cellRendererParams?: any;
    cellRendererSelector?: import("ag-grid-community").CellRendererSelectorFunc<any> | undefined;
    autoHeight?: boolean | undefined;
    wrapText?: boolean | undefined;
    enableCellChangeFlash?: boolean | undefined;
    suppressCellFlash?: boolean | undefined;
    rowDrag?: boolean | import("ag-grid-community").RowDragCallback<any> | undefined;
    rowDragText?: ((params: import("ag-grid-community").IRowDragItem, dragItemCount: number) => string) | undefined;
    dndSource?: boolean | import("ag-grid-community").DndSourceCallback<any> | undefined;
    dndSourceOnRowDrag?: ((params: import("ag-grid-community").DndSourceOnRowDragParams<any>) => void) | undefined;
    rowGroup?: boolean | undefined;
    initialRowGroup?: boolean | undefined;
    rowGroupIndex?: number | null | undefined;
    initialRowGroupIndex?: number | undefined;
    enableRowGroup?: boolean | undefined;
    enableValue?: boolean | undefined;
    aggFunc?: string | import("ag-grid-community").IAggFunc<any, any> | null | undefined;
    initialAggFunc?: string | import("ag-grid-community").IAggFunc<any, any> | undefined;
    defaultAggFunc?: string | undefined;
    allowedAggFuncs?: string[] | undefined;
    showRowGroup?: string | boolean | undefined;
    sortable?: boolean | undefined;
    sort?: import("ag-grid-community").SortDirection | undefined;
    initialSort?: import("ag-grid-community").SortDirection | undefined;
    sortIndex?: number | null | undefined;
    initialSortIndex?: number | undefined;
    sortingOrder?: import("ag-grid-community").SortDirection[] | undefined;
    comparator?: ((valueA: any, valueB: any, nodeA: import("ag-grid-community").IRowNode<any>, nodeB: import("ag-grid-community").IRowNode<any>, isDescending: boolean) => number) | undefined;
    unSortIcon?: boolean | undefined;
    colSpan?: ((params: import("ag-grid-community").ColSpanParams<any>) => number) | undefined;
    rowSpan?: ((params: import("ag-grid-community").RowSpanParams<any>) => number) | undefined;
    width?: number | undefined;
    initialWidth?: number | undefined;
    minWidth?: number | undefined;
    maxWidth?: number | undefined;
    flex?: number | undefined;
    initialFlex?: number | undefined;
    resizable?: boolean | undefined;
    suppressSizeToFit?: boolean | undefined;
    suppressAutoSize?: boolean | undefined;
    pivotValueColumn?: import("ag-grid-community").Column | null | undefined;
    pivotTotalColumnIds?: string[] | undefined;
    spanHeaderHeight?: boolean | undefined;
    headerName?: string | undefined;
    headerValueGetter?: string | import("ag-grid-community").HeaderValueGetterFunc<any> | undefined;
    headerTooltip?: string | undefined;
    headerClass?: import("ag-grid-community").HeaderClass<any> | undefined;
    suppressHeaderKeyboardEvent?: ((params: import("ag-grid-community").SuppressHeaderKeyboardEventParams<any>) => boolean) | undefined;
    columnGroupShow?: import("ag-grid-community").ColumnGroupShowType | undefined;
    toolPanelClass?: import("ag-grid-community").ToolPanelClass<any> | undefined;
    suppressColumnsToolPanel?: boolean | undefined;
    suppressFiltersToolPanel?: boolean | undefined;
    tooltipComponent?: any;
    tooltipComponentFramework?: any;
    tooltipComponentParams?: any;
    pivotKeys?: string[] | undefined;
    filter?: any;
    filterFramework?: any;
    filterParams?: any;
    floatingFilterComponent?: any;
    floatingFilterComponentFramework?: any;
    floatingFilterComponentParams?: any;
}[];
export declare const basicIntFormatter: Intl.NumberFormat;
export declare const stringFormatter: (params: ValueFormatterParams) => string;
export declare const isValidDate: (possibleDate: any) => boolean;
export declare const dateDisplayerDefault: (d: Date) => string;
export declare const getDatetimeFormatter: (colHint: ColumnDatetimeHint) => (params: ValueFormatterParams) => string;
export declare const boolDisplayer: (val: boolean) => "" | "False" | "True";
export declare const booleanFormatter: (params: ValueFormatterParams) => string;
export declare function dfToAgrid(tdf: DFWhole): [ColDef[], unknown[]];
